Attribute VB_Name = "Analysis"
Sub SetupAnalysis()
    Dim i As Integer
    Dim AnalysisForm As Worksheet
    Dim VehicleAveragesForm As Worksheet
    
    Set AnalysisForm = ActiveWorkbook.Worksheets("Analysis")
    Set VehicleAveragesForm = ActiveWorkbook.Worksheets("VehicleAverages")
    
    AnalysisForm.Cells(1, "A") = "T Confidence Interval"
    AnalysisForm.Cells(2, "A") = "Z Score"
    AnalysisForm.Cells(3, "A") = "MoE"
    
    AnalysisForm.Cells(2, "B") = 1.96
    AnalysisForm.Cells(3, "B") = 0.05
    
    AnalysisForm.Cells(1, "D") = "Vehicle Type"
    AnalysisForm.Cells(1, "E") = "Overall Time Averages"
    AnalysisForm.Cells(1, "F") = "Overall Standard Deviation"
    AnalysisForm.Cells(1, "G") = "Suggested Sample Size"
    'Sample Size = (z-score^2) * STDev/(MoE^2)
    AnalysisForm.Cells(1, "H") = "C, C = Z*SDev + Mean"
    'AnalysisForm.Cells(1, "G") = "C = Z*SDev + Mean"
    AnalysisForm.Cells(1, "I") = "Suggested Number of Simulations"
    
    
    AnalysisForm.Cells(2, "E") = WorksheetFunction.Average(VehicleAveragesForm.Range("I3:I29"))
    AnalysisForm.Cells(3, "E") = WorksheetFunction.Average(VehicleAveragesForm.Range("N3:N29"))
    AnalysisForm.Cells(4, "E") = WorksheetFunction.Average(VehicleAveragesForm.Range("S3:S29"))
    AnalysisForm.Cells(5, "E") = WorksheetFunction.Average(VehicleAveragesForm.Range("X3:X29"))
    AnalysisForm.Cells(6, "E") = WorksheetFunction.Average(VehicleAveragesForm.Range("Z3:Z29"))
    AnalysisForm.Cells(7, "E") = WorksheetFunction.Average(VehicleAveragesForm.Range("AB3:AB29"))
    
    For i = 2 To 7
        AnalysisForm.Cells(i, "D") = i - 2
        AnalysisForm.Cells(i, "F") = Sqr(WorksheetFunction.AverageIf(Worksheets("Travel Time").Range("M:M"), AnalysisForm.Cells(i, "D"), Worksheets("Travel Time").Range("O:O")))
        AnalysisForm.Cells(i, "G") = AnalysisForm.Cells(2, "B") ^ 2 * AnalysisForm.Cells(i, "F") / (AnalysisForm.Cells(3, "B") ^ 2)
        AnalysisForm.Cells(i, "H") = 0.975 * AnalysisForm.Cells(i, "F") + AnalysisForm.Cells(i, "E")
        AnalysisForm.Cells(i, "I") = ((AnalysisForm.Cells(i, "H") * AnalysisForm.Cells(i, "F")) / (AnalysisForm.Cells(i, "E") * AnalysisForm.Cells(3, "B"))) ^ 2
        
        
    Next i

    
    
    
End Sub


Sub FillStDev()
Dim i As Long
Dim fin As Long
Dim VehicleAveragesForm As Worksheet
Dim DataForm As Worksheet

Set VehicleAveragesForm = ActiveWorkbook.Worksheets("VehicleAverages")
Set DataForm = ActiveWorkbook.Worksheets("Travel Time")

fin = DataForm.Range("A" & Rows.Count).End(xlUp).Row
DataForm.Cells(1, "O") = "STDEV"

For i = 2 To fin
    Dim hour As Integer
    Dim minute As Integer
    Dim vtype As Integer
    Dim traveltime As Double
    
    hour = DataForm.Cells(i, "A")
    minute = DataForm.Cells(i, "B")
    vtype = DataForm.Cells(i, "M")
    traveltime = DataForm.Cells(i, "K")
    
      
    
    Dim timehour As Integer
    Dim timemin As Integer
    Dim avgtraveltime As Double
    Dim tloop As Integer
    
    For tloop = 3 To 29
        Dim mloop As Integer
        timehour = VehicleAveragesForm.Cells(tloop, "C")
        If timehour = hour Then
            timemin = VehicleAveragesForm.Cells(tloop, "D")
            
            If (minute >= timemin And minute <= 30) Then
                If vtype = 0 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "I")
                ElseIf vtype = 1 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "N")
                ElseIf vtype = 2 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "S")
                ElseIf vtype = 3 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "X")
                ElseIf vtype = 4 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "Z")
                ElseIf vtype = 5 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "AB")
                Exit For
                End If
                
            
                
            ElseIf (minute >= timemin And minute > 30) Then
                If vtype = 0 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "I")
                ElseIf vtype = 1 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "N")
                ElseIf vtype = 2 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "S")
                ElseIf vtype = 3 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "X")
                ElseIf vtype = 4 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "Z")
                ElseIf vtype = 5 Then
                    avgtraveltime = VehicleAveragesForm.Cells(tloop, "AB")
                Exit For
                End If
                
            End If
        End If
    Next tloop
    
    DataForm.Cells(i, "O") = (traveltime - avgtraveltime) ^ 2
    
Next i
End Sub

Sub runMe()
FillStDev
SetupAnalysis

End Sub
